#include <stdio.h>


int main(int argc, char** argv){

/*  <stdio.h>
	
	FILES
		fopen 		(abre y crea un archivo en disco)
		fclose 		(cierra un archivo que se ha abierto)
		feof 		(evalúa fin de archivo - End Of File)
		rewind 		(sitúa el cursor de lectura/escritura al principio del archivo)
		fseek 		(sitúa el cursor del archivo a un punto arbitrario)
	READ
		fgetc 		(lee un caracter a la vez de un archivo)
		fgets 		(lee cadenas de caracteres de un archivo)
		fread 		(lee un bloque de una "stream" de datos)
		fscanf 		(funciona igual que scanf, pero tomando un archivo)
	WRITE
		fputc 		(escribe un carácter a la vez en un archivo)
		fputs		(escribe una cadena de caractéres en un archivo)
		fwrite 		(escribie hacia un archivo)
		fprintf     (igual que printf, pero escribe en un archivo)
*/

	if (argc !=2){
		printf("ERROR! Cantidad de argumentos inválida.\n");
		return -1;
	}
	
	FILE *f = NULL;
	/*
	 * Con "r" abrirmos el archivo para leer
	 * Con "w" creamos un archivo para escribir, descartamos contenido anterior
	 * Con "a" creamos un archivo para escribir, escribimos al final del archivo
	 * Con "r+" abrimos un archivo como lectura y escritura
	 * Con "w+" abrimos un archivo como lectura y escrtura, descartamos el contenido anterior
	 * Con "a+" abrimos un archivo como lectura y escritura, comenzamos a escribir al final del archivo
	 */

	f = fopen(argv[1], "w+");
	if (f==NULL){
		printf("ERROR! No se pudo abrir el archivo.\n");
		return -2;
	}
	//fclose(f);

	/* Parte b */
    fputs("Hola, archivo\n", f );
    //fprintf(f, "%s", "Hola, archivo\n");
    //fclose(f);

	/*
	 * Salida con formato: probamos escribir con fprintf
	 */
/*	
	int a = 10;
	char b = 'P';
	fprintf(f,"Las dos variables definidas fueron %d y %c\n", a, b);	
	fclose(f);
*/
	/*
	 * Entrada con formato: probamos leer el archivo con fscanf
	 * %s lee un string sin espacios en blanco en el medio, 
	 * y lo asigna a un char* de tamano suficiente para guardar los caracteres
	 */
/*
	char s[100];
	fscanf(f,"%s", s);
	printf("Lo que leimos del archivo fue:\n\t%s\n",s);
	fclose(f);
*/
	/*
	 * Salida de caracter: fputc, fputs, putc
	 */
/*
	putc('M',f);
	fputc('\n',f);
	fputs("Probando fputs\n",f );
	fclose(f);
*/
	/*
	 * Entrada de caracter: fgetc, fgets, getc
	 */
	/*
    char t[10];
    
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	
	printf("%s\n",fgets(t, 10, f));
	printf("%c\n",getc(f));
	

	//Posicionamiento en los arhivos: fseek, rewind

	printf("\nVolvemos para atras\n");
	fseek(f,-15,SEEK_CUR);	
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	
	printf("%s\n",fgets(t, 10, f));
	printf("%c\n",getc(f));
	
	printf("\nVolvemos para atras nuevamente\n");
	rewind(f);
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	printf("%c\n",fgetc(f));
	
	printf("%s\n",fgets(t, 10, f));
	printf("%c\n",getc(f));
	fclose(f);
     */
}
